- todo = issuable_todo(issuable)

%aside.right-sidebar.js-right-sidebar.js-issuable-sidebar{ data: { signed: { in: current_user.present? } }, class: sidebar_gutter_collapsed_class, 'aria-live' => 'polite' }
  .issuable-sidebar{ data: { endpoint: "#{issuable_json_path(issuable)}" } }
    - can_edit_issuable = can?(current_user, :"admin_#{issuable.to_ability_name}", @project)
    .block.issuable-sidebar-header
      - if current_user
        %span.issuable-header-text.hide-collapsed.pull-left
          = _('Todo')
      %a.gutter-toggle.pull-right.js-sidebar-toggle{ role: "button", href: "#", "aria-label" => "Toggle sidebar" }
        = sidebar_gutter_toggle_icon
      - if current_user
        = render "shared/issuable/sidebar_todo", todo: todo, issuable: issuable

    = form_for [@project.namespace.becomes(Namespace), @project, issuable], remote: true, format: :json, html: { class: 'issuable-context-form inline-update js-issuable-update' } do |f|
      - if current_user
        .block.todo.hide-expanded
          = render "shared/issuable/sidebar_todo", todo: todo, issuable: issuable, is_collapsed: true
      .block.assignee
        = render "shared/issuable/sidebar_assignees", issuable: issuable, can_edit_issuable: can_edit_issuable, signed_in: current_user.present?
      .block.milestone
        .sidebar-collapsed-icon
          = icon('clock-o', 'aria-hidden': 'true')
          %span.milestone-title
            - if issuable.milestone
              %span.has-tooltip{ title: "#{issuable.milestone.title}<br>#{milestone_tooltip_title(issuable.milestone)}", data: { container: 'body', html: 1, placement: 'left' } }
                = issuable.milestone.title
            - else
              = _('None')
        .title.hide-collapsed
          = _('Milestone')
          = icon('spinner spin', class: 'hidden block-loading', 'aria-hidden': 'true')
          - if can_edit_issuable
            = link_to _('Edit'), '#', class: 'js-sidebar-dropdown-toggle edit-link pull-right'
        .value.hide-collapsed
          - if issuable.milestone
            = link_to issuable.milestone.title, milestone_path(issuable.milestone), class: "bold has-tooltip", title: milestone_tooltip_title(issuable.milestone), data: { container: "body", html: 1 }
          - else
            %span.no-value
              = _('None')

        .selectbox.hide-collapsed
          = f.hidden_field 'milestone_id', value: issuable.milestone_id, id: nil
          = dropdown_tag('Milestone', options: { title: _('Assign milestone'), toggle_class: 'js-milestone-select js-extra-options', filter: true, dropdown_class: 'dropdown-menu-selectable', placeholder: _('Search milestones'), data: { show_no: true, field_name: "#{issuable.to_ability_name}[milestone_id]", project_id: @project.id, issuable_id: issuable.id, milestones: project_milestones_path(@project, :json), ability_name: issuable.to_ability_name, issue_update: issuable_json_path(issuable), use_id: true, default_no: true, selected: (issuable.milestone.name if issuable.milestone), null_default: true }})
      - if issuable.has_attribute?(:time_estimate)
        #issuable-time-tracker.block
          // Fallback while content is loading
          .title.hide-collapsed
            = _('Time tracking')
            = icon('spinner spin', 'aria-hidden': 'true')
      - if issuable.has_attribute?(:due_date)
        .block.due_date
          .sidebar-collapsed-icon
            = icon('calendar', 'aria-hidden': 'true')
            %span.js-due-date-sidebar-value
              = issuable.due_date.try(:to_s, :medium) || 'None'
          .title.hide-collapsed
            = _('Due date')
            = icon('spinner spin', class: 'hidden block-loading', 'aria-hidden': 'true')
            - if can?(current_user, :"admin_#{issuable.to_ability_name}", @project)
              = link_to _('Edit'), '#', class: 'js-sidebar-dropdown-toggle edit-link pull-right'
          .value.hide-collapsed
            %span.value-content
              - if issuable.due_date
                %span.bold= issuable.due_date.to_s(:medium)
              - else
                %span.no-value
                  = _('No due date')
            - if can?(current_user, :"admin_#{issuable.to_ability_name}", @project)
              %span.no-value.js-remove-due-date-holder{ class: ("hidden" if issuable.due_date.nil?) }
                \-
                %a.js-remove-due-date{ href: "#", role: "button" }
                  = _('remove due date')
          - if can?(current_user, :"admin_#{issuable.to_ability_name}", @project)
            .selectbox.hide-collapsed
              = f.hidden_field :due_date, value: issuable.due_date.try(:strftime, 'yy-mm-dd')
              .dropdown
                %button.dropdown-menu-toggle.js-due-date-select{ type: 'button', data: { toggle: 'dropdown', field_name: "#{issuable.to_ability_name}[due_date]", ability_name: issuable.to_ability_name, issue_update: issuable_json_path(issuable) } }
                  %span.dropdown-toggle-text
                    = _('Due date')
                  = icon('chevron-down', 'aria-hidden': 'true')
                .dropdown-menu.dropdown-menu-due-date
                  = dropdown_title(_('Due date'))
                  = dropdown_content do
                    .js-due-date-calendar

      - if @labels
        - selected_labels = issuable.labels
        .block.labels
          .sidebar-collapsed-icon.js-sidebar-labels-tooltip{ title: issuable_labels_tooltip(issuable.labels_array), data: { placement: "left", container: "body" } }
            = icon('tags', 'aria-hidden': 'true')
            %span
              = selected_labels.size
          .title.hide-collapsed
            = _('Labels')
            = icon('spinner spin', class: 'hidden block-loading', 'aria-hidden': 'true')
            - if can_edit_issuable
              = link_to _('Edit'), '#', class: 'js-sidebar-dropdown-toggle edit-link pull-right'
          .value.issuable-show-labels.hide-collapsed{ class: ("has-labels" if selected_labels.any?) }
            - if selected_labels.any?
              - selected_labels.each do |label|
                = link_to_label(label, subject: issuable.project, type: issuable.to_ability_name)
            - else
              %span.no-value
                = _('None')
          .selectbox.hide-collapsed
            - selected_labels.each do |label|
              = hidden_field_tag "#{issuable.to_ability_name}[label_names][]", label.id, id: nil
            .dropdown
              %button.dropdown-menu-toggle.js-label-select.js-multiselect.js-label-sidebar-dropdown{ type: "button", data: {toggle: "dropdown", default_label: "Labels", field_name: "#{issuable.to_ability_name}[label_names][]", ability_name: issuable.to_ability_name, show_no: "true", show_any: "true", namespace_path: @project.try(:namespace).try(:full_path), project_path: @project.try(:path), issue_update: issuable_json_path(issuable), labels: (project_labels_path(@project, :json) if @project) } }
                %span.dropdown-toggle-text{ class: ("is-default" if selected_labels.empty?) }
                  = multi_label_name(selected_labels, "Labels")
                = icon('chevron-down', 'aria-hidden': 'true')
              .dropdown-menu.dropdown-select.dropdown-menu-paging.dropdown-menu-labels.dropdown-menu-selectable
                = render partial: "shared/issuable/label_page_default"
                - if can? current_user, :admin_label, @project and @project
                  = render partial: "shared/issuable/label_page_create"

      - if issuable.has_attribute?(:confidential)
        -# haml-lint:disable InlineJavaScript
        %script#js-confidential-issue-data{ type: "application/json" }= { is_confidential: @issue.confidential, is_editable: can_edit_issuable }.to_json.html_safe
        #js-confidential-entry-point

      - if issuable.has_attribute?(:discussion_locked)
        -# haml-lint:disable InlineJavaScript
        %script#js-lock-issue-data{ type: "application/json" }= { is_locked: issuable.discussion_locked?, is_editable: can_edit_issuable }.to_json.html_safe
        #js-lock-entry-point

      .js-sidebar-participants-entry-point

      - if current_user
        .js-sidebar-subscriptions-entry-point

      - project_ref = cross_project_reference(@project, issuable)
      .block.project-reference
        .sidebar-collapsed-icon.dont-change-state
          = clipboard_button(text: project_ref, title: _('Copy reference to clipboard'), placement: "left")
        .cross-project-reference.hide-collapsed
          %span
            = _('Reference:')
            %cite{ title: project_ref }
              = project_ref
          = clipboard_button(text: project_ref, title: _('Copy reference to clipboard'), placement: "left")
      - if current_user && issuable.can_move?(current_user)
        .block.js-sidebar-move-issue-block
          .sidebar-collapsed-icon{ data: { toggle: 'tooltip', placement: 'left', container: 'body' }, title: _('Move issue') }
            = custom_icon('icon_arrow_right')
          .dropdown.sidebar-move-issue-dropdown.hide-collapsed
            %button.btn.btn-default.btn-block.js-sidebar-dropdown-toggle.js-move-issue{ type: 'button',
              data: { toggle: 'dropdown' } }
              = _('Move issue')
            .dropdown-menu.dropdown-menu-selectable
              = dropdown_title(_('Move issue'))
              = dropdown_filter(_('Search project'), search_id: 'sidebar-move-issue-dropdown-search')
              = dropdown_content
              = dropdown_loading
              = dropdown_footer add_content_class: true do
                %button.btn.btn-new.sidebar-move-issue-confirmation-button.js-move-issue-confirmation-button{ disabled: true }
                  = _('Move')
                  = icon('spinner spin', class: 'sidebar-move-issue-confirmation-loading-icon')

    -# haml-lint:disable InlineJavaScript
    %script.js-sidebar-options{ type: "application/json" }= issuable_sidebar_options(issuable, can_edit_issuable).to_json.html_safe
